function [J,wr1s,ini] = JSI2Scsi(beta,mu,N,ss,ii)

%Code for Vectorised SI2S Jump chain T.P. matrix for evaluating
%offspring distribution
%tic
ms=ss(1); Ms=ss(end);  mi=ii(1); Mi=ii(end);
[SS,II]=meshgrid(ms:Ms,mi:Mi);
ls=1+Ms-ms; li=1+Mi-mi;
SIZE1 = li*ls;
SIZE = 4*SIZE1;
OK = sign(SS+II-(N+0.5));
OK = (1-OK)/2;
V=reshape(cumsum(reshape(OK,SIZE1,1)),li,ls).*OK;
J1 = sparse([],[],[],SIZE,SIZE);

%INFECTION NOT INITIAL, INITIAL in 1
%r=0
OK1 = sign(SS-0.5);
OK2 = sign(II-0.5);
OK3 = sign((N-SS)-1.5);
OK4 = OK1 + OK2 + OK3 + OK;
posI = find(OK4==4);
posIdc = find(posI-N>0);
IProb = ((beta.*SS.*(N-SS-1)/(N-1))./(beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS))).*OK;
J1 = J1 + sparse(posI(posIdc),posI(posIdc)-N,IProb(posI(posIdc)),SIZE,SIZE);
%r=1
OK1 = sign(SS-0.5);
OK2 = sign(II-1.5);
OK3 = OK1 + OK2 + OK;
posI = find(OK3==3);
posIdc = find(posI-N>0);
IProb = ((beta.*SS.*(N-SS-1)/(N-1))./(beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS))).*OK;
J1 = J1 + sparse(posI(posIdc)+2*SIZE1, posI(posIdc)-N, IProb(posI(posIdc)), SIZE, SIZE);

%INFECTION NOT INITIAL, INITIAL in 2
%r=0
OK1 = sign(SS-0.5);
OK2 = sign(N-0.5 - SS+II);
OK3 = sign(N-SS-1.5);
OK4 = OK1 + OK2 + OK3 + OK;
posI = find(OK4==4);
posIdc = find(posI-N>0);
IProb = ((beta.*SS.*(N-SS-1)/(N-1))./(beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS))).*OK;
J1 = J1 + sparse(posI(posIdc)+SIZE1,posI(posIdc)+SIZE1-N,IProb(posI(posIdc)),SIZE,SIZE);
%r=1
OK1 = sign(SS-0.5);
OK2 = sign(N-SS-II-0.5);
OK3 = sign(II-0.5);
OK4 = OK1 + OK2 + OK3 + OK;
posI = find(OK4==4);
posIdc = find(posI-N>0);
IProb = ((beta.*SS.*(N-SS-1)/(N-1))./(beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS))).*OK;
J1 = J1 + sparse(posI(posIdc)+3*SIZE1,posI(posIdc)+SIZE1-N,IProb(posI(posIdc)),SIZE,SIZE);

%INFECTION INITIAL, INITIAL in 1
%r=0
OK1 = sign(SS-0.5);
OK2 = sign(II-0.5);
OK3 = OK1 + OK2 + OK;
posI = find(OK3==3);
posIdc = find(posI-N>0);
IProb = ((beta.*SS/(N-1))./(beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS))).*OK;
J1 = J1 + sparse(posI(posIdc),posI(posIdc)+2*SIZE1-N,IProb(posI(posIdc)),SIZE,SIZE);
%r=1
OK1 = sign(SS-0.5);
OK2 = sign(II-1.5);
OK3 = OK1 + OK2 + OK;
posI = find(OK3==3);
posIdc = find(posI-N>0);
IProb = ((beta.*SS/(N-1))./(beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS))).*OK;
J1 = J1 + sparse(posI(posIdc)+2*SIZE1,posI(posIdc)+2*SIZE1-N,IProb(posI(posIdc)),SIZE,SIZE);

%INFECTION INITIAL, INITIAL in 2
%r=0
OK1 = sign(SS-0.5);
OK2 = sign(N-SS-II-0.5);
OK3 = OK1 + OK2 + OK;
posI = find(OK3==3);
posIdc = find(posI-N>0);
IProb = ((beta.*SS/(N-1))./(beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS))).*OK;
J1 = J1 + sparse(posI(posIdc)+SIZE1,posI(posIdc)+3*SIZE1-N,IProb(posI(posIdc)),SIZE,SIZE);
%r=1
OK1 = sign(SS-0.5);
OK2 = sign(N-SS-II-0.5);
OK3 = sign(II-0.5);
OK4 = OK1 + OK2 + OK3 + OK;
posI = find(OK4==4);
posIdc = find(posI-N>0);
IProb = ((beta.*SS/(N-1))./(beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS))).*OK;
J1 = J1 + sparse(posI(posIdc)+3*SIZE1,posI(posIdc)+3*SIZE1-N,IProb(posI(posIdc)),SIZE,SIZE);


%RECOVERY 1, NOT INITIAL, INITIAL 1
%r=0
OK1 = sign(II-1.5);
OK2 = OK1 + OK;
posR1 = find(OK2==2);
posR1dc = find(posR1-1>0);
R1Prob = (2*mu.*(II-1)./((beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS)))).*OK;
J1 = J1 + sparse(posR1(posR1dc),posR1(posR1dc)-1,R1Prob(posR1(posR1dc)),SIZE,SIZE);
%r=1
OK1 = sign(II-1.5);
OK2 = OK1 + OK;
posR1 = find(OK2==2);
posR1dc = find(posR1-1>0);
R1Prob = (2*mu.*(II-1)./((beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS)))).*OK;
J1 = J1 + sparse(posR1(posR1dc)+2*SIZE1,posR1(posR1dc)-1,R1Prob(posR1(posR1dc)),SIZE,SIZE);

%RECOVERY 1, NOT INITIAL, INITIAL 2
%r=0
OK1 = sign(II-0.5);
OK2 = sign(N-SS-II-0.5);
OK3 = OK1 + OK2 + OK;
posR1 = find(OK3==3);
posR1dc = find(posR1-1>0);
R1Prob = (2*mu.*II./((beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS)))).*OK;
J1 = J1 + sparse(posR1(posR1dc)+SIZE1,posR1(posR1dc)+SIZE1-1,R1Prob(posR1(posR1dc)),SIZE,SIZE);
%r=1
OK1 = sign(II-0.5);
OK2 = sign(N-SS-II-0.5);
OK3 = OK1 + OK2 + OK;
posR1 = find(OK3==3);
posR1dc = find(posR1-1>0);
R1Prob = (2*mu.*II./((beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS)))).*OK;
J1 = J1 + sparse(posR1(posR1dc)+3*SIZE1,posR1(posR1dc)+SIZE1-1,R1Prob(posR1(posR1dc)),SIZE,SIZE);

%RECOVERY 1, INITIAL
%r=0
OK1 = sign(II-0.5);
OK2 = OK1 + OK;
posR1 = find(OK2==2);
posR1dc = find(posR1-1>0);
R1Prob = (2*mu./((beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS)))).*OK;
J1 = J1 + sparse(posR1(posR1dc),posR1(posR1dc)+SIZE1-1,R1Prob(posR1(posR1dc)),SIZE,SIZE);
%r=1
OK1 = sign(II-1.5);
OK2 = OK1 + OK;
posR1 = find(OK2==2);
posR1dc = find(posR1-1>0);
R1Prob = (2*mu./((beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS)))).*OK;
J1 = J1 + sparse(posR1(posR1dc)+2*SIZE1,posR1(posR1dc)+SIZE1-1,R1Prob(posR1(posR1dc)),SIZE,SIZE);

%RECOVERY 2, NOT INITIAL, INITIAL 1
%r=0
OK1 = sign(N-SS-II-0.5);
OK2 = sign(II-0.5);
OK3 = OK1 + OK2 + OK;
posR2 = find(OK3==3);
posR2dc = find(posR2+(N+1)<SIZE1+1);
R2Prob = (2*mu.*(N-SS-II)./((beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS)))).*OK;
J1 = J1 + sparse(posR2(posR2dc),posR2(posR2dc)+(N+1),R2Prob(posR2(posR2dc)),SIZE,SIZE);
%r=1
OK1 = sign(N-SS-II-0.5);
OK2 = sign(II-1.5);
OK3 = OK1 + OK2 + OK;
posR2 = find(OK3==3);
posR2dc = find(posR2+(N+1)<SIZE1+1);
R2Prob = (2*mu.*(N-SS-II)./((beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS)))).*OK;
J1 = J1 + sparse(posR2(posR2dc)+2*SIZE1,posR2(posR2dc)+(N+1),R2Prob(posR2(posR2dc)),SIZE,SIZE);

%RECOVERY 2, NOT INITIAL, INITIAL 2
%r=0
OK1 = sign(N-SS-II-1.5);
OK2 = OK1 + OK;
posR2 = find(OK2==2);
posR2dc = find(posR2+(N+1)<SIZE1+1);
R2Prob = (2*mu.*(N-SS-II-1)./((beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS)))).*OK;
J1 = J1 + sparse(posR2(posR2dc)+SIZE1,posR2(posR2dc)+SIZE1+(N+1),R2Prob(posR2(posR2dc)),SIZE,SIZE);
%r=1
OK1 = sign(N-SS-II-1.5);
OK2 = sign(II-0.5);
OK3 = OK1 + OK2 + OK;
posR2 = find(OK3==3);
posR2dc = find(posR2+(N+1)<SIZE1+1);
R2Prob = (2*mu.*(N-SS-II-1)./((beta.*SS.*(N-SS)/(N-1) + 2*mu.*(N-SS)))).*OK;
J1 = J1 + sparse(posR2(posR2dc)+3*SIZE1,posR2(posR2dc)+SIZE1+(N+1),R2Prob(posR2(posR2dc)),SIZE,SIZE);


%FINAL MATRIX
OKF0 = sign(0.5-SS);
OKF0 = (1-OKF0)/2;

OKF1 = sign(0.5-II);
OKF1 = (1-OKF1)/2;

OKF2 = sign(0.5-(N-SS-II));
OKF2 = (1-OKF2)/2;

OKF3 = sign(1.5-II);
OKF3 = (1-OKF3)/2;

OKF4i = sign(0.5-II);
OKF4i = (1-OKF4i)/2;
OKF4ii = sign(0.5-(N-SS-II));
OKF4ii = (1-OKF4ii)/2;

OKFC = sign(SS+N);
VF1=reshape(cumsum(reshape(OKFC,SIZE1,1)),li,ls).*OK.*OKF0.*OKF1;
VF2=reshape(cumsum(reshape(OKFC,SIZE1,1)),li,ls).*OK.*OKF0.*OKF2;
VF3=reshape(cumsum(reshape(OKFC,SIZE1,1)),li,ls).*OK.*OKF0.*OKF3;
VF4=reshape(cumsum(reshape(OKFC,SIZE1,1)),li,ls).*OK.*OKF0.*OKF4i.*OKF4ii;

posFinal1 = find(VF1>0)';
posFinal2 = find(VF2>0)';
posFinal3 = find(VF3>0)';
posFinal4 = find(VF4>0)';

wr1s = length(posFinal1) + length(posFinal2) + 1;

finalpos = [posFinal1, SIZE1 + posFinal2, 2*SIZE1 + posFinal3, 3*SIZE1 + posFinal4];
 
J = J1(finalpos,finalpos);

ini = find(posFinal1==(N+1)*(N-1)+2);
%toc
