function [J,wr1s,ini] = JSIRcsi(beta,gamma,N,ss,ii)

%Josh's Code for Vectorised SIR Jump chain T.P. matrix for evaluating
%offspring distribution
%tic
ms=ss(1); Ms=ss(end);  mi=ii(1); Mi=ii(end);
[SS,II]=meshgrid(ms:Ms,mi:Mi);
ls=1+Ms-ms; li=1+Mi-mi;
SIZE1 = li*ls;
SIZE = 2*SIZE1;
OK = sign(SS+II-(N+0.5));
OK = (1-OK)/2;
%V=reshape(cumsum(reshape(OK,SIZE1,1)),li,ls).*OK;
J1 = sparse([],[],[],SIZE,SIZE);

%INFECTION NOT INITIAL
%r=0
OK1 = sign(SS-0.5);
OK2 = sign(II-1.5);
OK3 = OK1 + OK2 + OK;
posI = find(OK3==3);
posIdc = find(posI-N>0);
IProb = ((beta.*SS.*(II-1)/(N-1))./(beta.*SS.*II/(N-1) + gamma.*II)).*OK;
J1 = J1 + sparse(posI(posIdc),posI(posIdc)-N,IProb(posI(posIdc)),SIZE,SIZE);
%r=1
OK1 = sign(SS-0.5);
OK2 = sign(II-1.5);
OK3 = OK1 + OK2 + OK;
posI = find(OK3==3);
posIdc = find(posI-N>0);
IProb = ((beta.*SS.*(II-1)/(N-1))./(beta.*SS.*II/(N-1) + gamma.*II)).*OK;
J1 = J1 + sparse(posI(posIdc)+SIZE1, posI(posIdc)-N, IProb(posI(posIdc)), SIZE, SIZE);

%INFECTION INITIAL
%r=0
OK1 = sign(SS-0.5);
OK2 = sign(II-0.5);
OK3 = OK1 + OK2 + OK;
posI = find(OK3==3);
%posIdc = find(posI-N>0)
posIdc = find(posI>0);
IProb = ((beta.*SS/(N-1))./(beta.*SS.*II/(N-1) + gamma.*II)).*OK;
J1 = J1 + sparse(posI(posIdc),posI(posIdc)+SIZE1-N,IProb(posI(posIdc)),SIZE,SIZE);
%r=1
OK1 = sign(SS-0.5);
OK2 = sign(II-1.5);
OK3 = OK1 + OK2 + OK;
posI = find(OK3==3);
%posIdc = find(posI-N>0);
posIdc = find(posI>0);
IProb = ((beta.*SS/(N-1))./(beta.*SS.*II/(N-1) + gamma.*II)).*OK;
J1 = J1 + sparse(posI(posIdc)+SIZE1,posI(posIdc)+SIZE1-N,IProb(posI(posIdc)),SIZE,SIZE);

%RECOVERY, NOT INITIAL
%r=0
OK1 = sign(II-1.5);
OK2 = OK1 + OK;
posR1 = find(OK2==2);
posR1dc = find(posR1-1>0);
R1Prob = (gamma.*(II-1)./((beta.*SS.*II/(N-1) + gamma.*II))).*OK;
J1 = J1 + sparse(posR1(posR1dc),posR1(posR1dc)-1,R1Prob(posR1(posR1dc)),SIZE,SIZE);
%r=1
OK1 = sign(II-1.5);
OK2 = OK1 + OK;
posR1 = find(OK2==2);
posR1dc = find(posR1-1>0);
R1Prob = (gamma.*(II-1)./((beta.*SS.*II/(N-1) + gamma.*II))).*OK;
J1 = J1 + sparse(posR1(posR1dc)+SIZE1,posR1(posR1dc)-1,R1Prob(posR1(posR1dc)),SIZE,SIZE);


%FINAL MATRIX
OKF0 = sign(0.5-SS);
OKF0 = (1-OKF0)/2;

OKF1 = sign(0.5-II);
OKF1 = (1-OKF1)/2;

OKF2 = sign(1.5-II);
OKF2 = (1-OKF2)/2;

OKFC = sign(SS+N+0.5);

VF1=reshape(cumsum(reshape(OKFC,SIZE1,1)),li,ls).*OK.*OKF1.*OKF0;
VF2=reshape(cumsum(reshape(OKFC,SIZE1,1)),li,ls).*OK.*OKF2;

posFinal1 = find(VF1>0)';
posFinal2 = find(VF2>0)';

wr1s = length(posFinal1) + 1;

finalpos = [posFinal1, SIZE1 + posFinal2];
 
J = J1(finalpos,finalpos);

ini = find(posFinal1==(N+1)*(N-1)+2);
%toc
