function dsi = SISdsiSLE(beta,mu,N,k)

%form jump chain
J = SISJvect(beta,mu,N);
%restrict to non-absorbing class
JC = J(2:end,2:end);
lJC = length(JC);
%get absorbing jump probabilities
JCv = ones(1,lJC)-sum(JC');

%form matrix jumps with cost 0
JCcost = JC(1:N,1:N);
lJCcost = length(JCcost);

%p0 -- is 0 for when costs are 1, and when costs are 0 solution of SLEs
outv0 = (speye(lJCcost)-JCcost)\JCv(1:lJCcost)';
dsi(1) = outv0(1);

%p1 -- explicit solution when costs are 1, and when costs are 0 SLEs
%full p0 vector
fullv0 = [outv0; zeros(lJC-length(outv0),1)];
%p1 when costs are 1
pc1 = JC(N+1:end,:)*fullv0 + JCv(N+1:end)';
%solving SLEs
pvd = JC(1:N,N+1:end)*pc1;
outv = (speye(lJCcost)-JCcost)\pvd;
dsi(2) = outv(1);

%p2 -- pk
for ki = 2:k
    fullv = [outv; pc1];
    pc1 = JC(N+1:end,:)*fullv;
    pvd = JC(1:N,N+1:end)*pc1;
    outv = (speye(lJCcost)-JCcost)\pvd;
    dsi(ki+1) = outv(1);
end
